/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.tutorial ;

import org.azuki.framework.annotation.*;
import org.azuki.framework.context.*;

/**
* @author Robert Bakic
*/
public class PriceCtx
{
	final static private double DEFAULT_RATE = 20.0 ; // Default value (if context's rate not defined)
	
	@Export
	@MethodInfo(desc="This method calculate a discount, using a rate value defined in the context")
	final public Double calculateDiscount(Double price)
	throws Exception
	{
		String strate = (String)ThreadContext.lookup("rate") ;
		
		double rate = DEFAULT_RATE ;
		
		if(!(strate==null || strate.isEmpty()))
			rate = new Double(strate).doubleValue() ;
		else
			Log.warning("Rate value is not defined") ;
		
		return new Double(price.doubleValue()*rate/100) ;
	}
}